diff --git a/python/mozbuild/mozbuild/backend/recursivemake.py b/python/mozbuild/mozbuild/backend/recursivemake.py
index 7f3b36c597..f5ac13769f 100644
--- a/python/mozbuild/mozbuild/backend/recursivemake.py
+++ b/python/mozbuild/mozbuild/backend/recursivemake.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import logging
 import os
@@ -12,7 +11,7 @@ from collections import (
     defaultdict,
     namedtuple,
 )
-from StringIO import StringIO
+from io import StringIO
 from itertools import chain
 
 from mozpack.manifests import (
@@ -68,80 +67,81 @@ from ..util import (
 )
 from ..makeutil import Makefile
 from mozbuild.shellutil import quote as shell_quote
+from functools import reduce
 
 MOZBUILD_VARIABLES = [
-    b'ASFLAGS',
-    b'CMSRCS',
-    b'CMMSRCS',
-    b'CPP_UNIT_TESTS',
-    b'DIRS',
-    b'DIST_INSTALL',
-    b'EXTRA_DSO_LDOPTS',
-    b'EXTRA_JS_MODULES',
-    b'EXTRA_PP_COMPONENTS',
-    b'EXTRA_PP_JS_MODULES',
-    b'FORCE_SHARED_LIB',
-    b'FORCE_STATIC_LIB',
-    b'FINAL_LIBRARY',
-    b'HOST_CFLAGS',
-    b'HOST_CSRCS',
-    b'HOST_CMMSRCS',
-    b'HOST_CXXFLAGS',
-    b'HOST_EXTRA_LIBS',
-    b'HOST_LIBRARY_NAME',
-    b'HOST_PROGRAM',
-    b'HOST_SIMPLE_PROGRAMS',
-    b'IS_COMPONENT',
-    b'JAR_MANIFEST',
-    b'JAVA_JAR_TARGETS',
-    b'LD_VERSION_SCRIPT',
-    b'LIBRARY_NAME',
-    b'LIBS',
-    b'MAKE_FRAMEWORK',
-    b'MODULE',
-    b'NO_DIST_INSTALL',
-    b'NO_EXPAND_LIBS',
-    b'NO_INTERFACES_MANIFEST',
-    b'NO_JS_MANIFEST',
-    b'OS_LIBS',
-    b'PARALLEL_DIRS',
-    b'PREF_JS_EXPORTS',
-    b'PROGRAM',
-    b'PYTHON_UNIT_TESTS',
-    b'RESOURCE_FILES',
-    b'SDK_HEADERS',
-    b'SDK_LIBRARY',
-    b'SHARED_LIBRARY_LIBS',
-    b'SHARED_LIBRARY_NAME',
-    b'SIMPLE_PROGRAMS',
-    b'SONAME',
-    b'STATIC_LIBRARY_NAME',
-    b'TEST_DIRS',
-    b'TOOL_DIRS',
+    'ASFLAGS',
+    'CMSRCS',
+    'CMMSRCS',
+    'CPP_UNIT_TESTS',
+    'DIRS',
+    'DIST_INSTALL',
+    'EXTRA_DSO_LDOPTS',
+    'EXTRA_JS_MODULES',
+    'EXTRA_PP_COMPONENTS',
+    'EXTRA_PP_JS_MODULES',
+    'FORCE_SHARED_LIB',
+    'FORCE_STATIC_LIB',
+    'FINAL_LIBRARY',
+    'HOST_CFLAGS',
+    'HOST_CSRCS',
+    'HOST_CMMSRCS',
+    'HOST_CXXFLAGS',
+    'HOST_EXTRA_LIBS',
+    'HOST_LIBRARY_NAME',
+    'HOST_PROGRAM',
+    'HOST_SIMPLE_PROGRAMS',
+    'IS_COMPONENT',
+    'JAR_MANIFEST',
+    'JAVA_JAR_TARGETS',
+    'LD_VERSION_SCRIPT',
+    'LIBRARY_NAME',
+    'LIBS',
+    'MAKE_FRAMEWORK',
+    'MODULE',
+    'NO_DIST_INSTALL',
+    'NO_EXPAND_LIBS',
+    'NO_INTERFACES_MANIFEST',
+    'NO_JS_MANIFEST',
+    'OS_LIBS',
+    'PARALLEL_DIRS',
+    'PREF_JS_EXPORTS',
+    'PROGRAM',
+    'PYTHON_UNIT_TESTS',
+    'RESOURCE_FILES',
+    'SDK_HEADERS',
+    'SDK_LIBRARY',
+    'SHARED_LIBRARY_LIBS',
+    'SHARED_LIBRARY_NAME',
+    'SIMPLE_PROGRAMS',
+    'SONAME',
+    'STATIC_LIBRARY_NAME',
+    'TEST_DIRS',
+    'TOOL_DIRS',
     # XXX config/Makefile.in specifies this in a make invocation
     #'USE_EXTENSION_MANIFEST',
-    b'XPCSHELL_TESTS',
-    b'XPIDL_MODULE',
+    'XPCSHELL_TESTS',
+    'XPIDL_MODULE',
 ]
 
 DEPRECATED_VARIABLES = [
-    b'EXPORT_LIBRARY',
-    b'EXTRA_LIBS',
-    b'HOST_LIBS',
-    b'LIBXUL_LIBRARY',
-    b'MOCHITEST_A11Y_FILES',
-    b'MOCHITEST_BROWSER_FILES',
-    b'MOCHITEST_BROWSER_FILES_PARTS',
-    b'MOCHITEST_CHROME_FILES',
-    b'MOCHITEST_FILES',
-    b'MOCHITEST_FILES_PARTS',
-    b'MOCHITEST_METRO_FILES',
-    b'MOCHITEST_ROBOCOP_FILES',
-    b'MODULE_OPTIMIZE_FLAGS',
-    b'MOZ_CHROME_FILE_FORMAT',
-    b'SHORT_LIBNAME',
-    b'TESTING_JS_MODULES',
-    b'TESTING_JS_MODULE_DIR',
+    'EXPORT_LIBRARY',
+    'EXTRA_LIBS',
+    'HOST_LIBS',
+    'LIBXUL_LIBRARY',
+    'MOCHITEST_A11Y_FILES',
+    'MOCHITEST_BROWSER_FILES',
+    'MOCHITEST_BROWSER_FILES_PARTS',
+    'MOCHITEST_CHROME_FILES',
+    'MOCHITEST_FILES',
+    'MOCHITEST_FILES_PARTS',
+    'MOCHITEST_METRO_FILES',
+    'MOCHITEST_ROBOCOP_FILES',
+    'MODULE_OPTIMIZE_FLAGS',
+    'MOZ_CHROME_FILE_FORMAT',
+    'SHORT_LIBNAME',
+    'TESTING_JS_MODULES',
+    'TESTING_JS_MODULE_DIR',
 ]
 
 MOZBUILD_VARIABLES_MESSAGE = 'It should only be defined in moz.build files.'
@@ -153,10 +153,10 @@ DEPRECATED_VARIABLES_MESSAGE = (
 
 
 def make_quote(s):
-    return s.replace('#', '\#').replace('$', '$$')
+    return s.replace('#', r'\#').replace('$', '$$')
 
 
-class BackendMakeFile(object):
+class BackendMakeFile:
     """Represents a generated backend.mk file.
 
     This is both a wrapper around a file handle as well as a container that
@@ -200,7 +200,7 @@ class BackendMakeFile(object):
         self.fh.write(buf)
 
     def write_once(self, buf):
-        if isinstance(buf, unicode):
+        if isinstance(buf, str):
             buf = buf.encode('utf-8')
         if b'\n' + buf not in self.fh.getvalue():
             self.write(buf)
@@ -227,7 +227,7 @@ class BackendMakeFile(object):
         return self.fh.diff
 
 
-class RecursiveMakeTraversal(object):
+class RecursiveMakeTraversal:
     """
     Helper class to keep track of how the "traditional" recursive make backend
     recurses subdirectories. This is useful until all adhoc rules are removed
@@ -269,8 +269,8 @@ class RecursiveMakeTraversal(object):
         Helper function to call a filter from compute_dependencies and
         traverse.
         """
-        return filter(current, self._traversal.get(current,
-            self.SubDirectories()))
+        return list(filter(current, self._traversal.get(current,
+            self.SubDirectories())))
 
     def compute_dependencies(self, filter=None):
         """
@@ -329,11 +329,9 @@ class RecursiveMakeTraversal(object):
         if not start in self._traversal:
             return
         for node in parallel:
-            for n in self.traverse(node, filter):
-                yield n
+            yield from self.traverse(node, filter)
         for dir in sequential:
-            for d in self.traverse(dir, filter):
-                yield d
+            yield from self.traverse(dir, filter)
 
     def get_subdirs(self, dir):
         """
@@ -391,7 +389,7 @@ class RecursiveMakeBackend(CommonBackend):
         }
 
     def summary(self):
-        summary = super(RecursiveMakeBackend, self).summary()
+        summary = super().summary()
         summary.extend('; {makefile_in:d} -> {makefile_out:d} Makefile',
                        makefile_in=self._makefile_in_count,
                        makefile_out=self._makefile_out_count)
@@ -456,7 +454,7 @@ class RecursiveMakeBackend(CommonBackend):
             for f in sorted(obj.files):
                 f = mozpath.relpath(f, base)
                 for var in variables:
-                    backend_file.write('%s += %s\n' % (var, f))
+                    backend_file.write('{} += {}\n'.format(var, f))
         elif isinstance(obj, HostSources):
             suffix_map = {
                 '.c': 'HOST_CSRCS',
@@ -465,7 +463,7 @@ class RecursiveMakeBackend(CommonBackend):
             }
             var = suffix_map[obj.canonical_suffix]
             for f in sorted(obj.files):
-                backend_file.write('%s += %s\n' % (
+                backend_file.write('{} += {}\n'.format(
                     var, mozpath.relpath(f, backend_file.srcdir)))
         elif isinstance(obj, VariablePassthru):
             # Sorted so output is consistent and we don't bump mtimes.
@@ -476,12 +474,12 @@ class RecursiveMakeBackend(CommonBackend):
                 if isinstance(v, list):
                     for item in v:
                         backend_file.write(
-                            '%s += %s\n' % (k, make_quote(shell_quote(item))))
+                            '{} += {}\n'.format(k, make_quote(shell_quote(item))))
                 elif isinstance(v, bool):
                     if v:
                         backend_file.write('%s := 1\n' % k)
                 else:
-                    backend_file.write('%s := %s\n' % (k, v))
+                    backend_file.write('{} := {}\n'.format(k, v))
         elif isinstance(obj, HostDefines):
             self._process_defines(obj, backend_file, which='HOST_DEFINES')
         elif isinstance(obj, Defines):
@@ -499,10 +497,10 @@ class RecursiveMakeBackend(CommonBackend):
             self._no_skip[tier].add(backend_file.relobjdir)
             first_output = obj.outputs[0]
             dep_file = "%s.pp" % first_output
-            backend_file.write('%s:: %s\n' % (tier, first_output))
+            backend_file.write('{}:: {}\n'.format(tier, first_output))
             for output in obj.outputs:
                 if output != first_output:
-                    backend_file.write('%s: %s ;\n' % (output, first_output))
+                    backend_file.write('{}: {} ;\n'.format(output, first_output))
                 backend_file.write('GARBAGE += %s\n' % output)
             backend_file.write('EXTRA_MDDEPEND_FILES += %s\n' % dep_file)
             if obj.script:
@@ -645,17 +643,17 @@ class RecursiveMakeBackend(CommonBackend):
             for dir, deps in all_deps.items():
                 if deps is not None or (dir in self._idl_dirs \
                                         and tier == 'export'):
-                    rule = root_deps_mk.create_rule(['%s/%s' % (dir, tier)])
+                    rule = root_deps_mk.create_rule(['{}/{}'.format(dir, tier)])
                 if deps:
-                    rule.add_dependencies('%s/%s' % (d, tier) for d in deps if d)
+                    rule.add_dependencies('{}/{}'.format(d, tier) for d in deps if d)
                 if dir in self._idl_dirs and tier == 'export':
                     rule.add_dependencies(['xpcom/xpidl/%s' % tier])
             rule = root_deps_mk.create_rule(['recurse_%s' % tier])
             if main:
-                rule.add_dependencies('%s/%s' % (d, tier) for d in main)
+                rule.add_dependencies('{}/{}'.format(d, tier) for d in main)
 
         all_compile_deps = reduce(lambda x,y: x|y,
-            self._compile_graph.values()) if self._compile_graph else set()
+            list(self._compile_graph.values())) if self._compile_graph else set()
         compile_roots = set(self._compile_graph.keys()) - all_compile_deps
 
         rule = root_deps_mk.create_rule(['recurse_compile'])
@@ -670,7 +668,7 @@ class RecursiveMakeBackend(CommonBackend):
         # Fill root.mk with the convenience variables.
         for tier, filter in filters:
             all_dirs = self._traversal.traverse('', filter)
-            root_mk.add_statement('%s_dirs := %s' % (tier, ' '.join(all_dirs)))
+            root_mk.add_statement('{}_dirs := {}'.format(tier, ' '.join(all_dirs)))
 
         # Need a list of compile targets because we can't use pattern rules:
         # https://savannah.gnu.org/bugs/index.php?42833
@@ -701,7 +699,7 @@ class RecursiveMakeBackend(CommonBackend):
         makefile.add_statement(explanation)
 
         all_sources = ' '.join(source for source, _ in unified_source_mapping)
-        makefile.add_statement('%s := %s' % (unified_files_makefile_variable,
+        makefile.add_statement('{} := {}'.format(unified_files_makefile_variable,
                                              all_sources))
 
         if include_curdir_build_rules:
@@ -715,14 +713,14 @@ class RecursiveMakeBackend(CommonBackend):
             rule.add_dependencies(['$(CURDIR)/%: %'])
 
     def _check_blacklisted_variables(self, makefile_in, makefile_content):
-        if b'EXTERNALLY_MANAGED_MAKE_FILE' in makefile_content:
+        if 'EXTERNALLY_MANAGED_MAKE_FILE' in makefile_content:
             # Bypass the variable restrictions for externally managed makefiles.
             return
 
         for l in makefile_content.splitlines():
             l = l.strip()
             # Don't check comments
-            if l.startswith(b'#'):
+            if l.startswith('#'):
                 continue
             for x in chain(MOZBUILD_VARIABLES, DEPRECATED_VARIABLES):
                 if x not in l:
@@ -779,11 +777,11 @@ class RecursiveMakeBackend(CommonBackend):
                     # Skip every directory but those with a Makefile
                     # containing a tools target, or XPI_PKGNAME or
                     # INSTALL_EXTENSION_ID.
-                    for t in (b'XPI_PKGNAME', b'INSTALL_EXTENSION_ID',
-                            b'tools'):
+                    for t in ('XPI_PKGNAME', 'INSTALL_EXTENSION_ID',
+                            'tools'):
                         if t not in content:
                             continue
-                        if t == b'tools' and not re.search('(?:^|\s)tools.*::', content, re.M):
+                        if t == 'tools' and not re.search(r'(?:^|\s)tools.*::', content, re.M):
                             continue
                         if objdir == self.environment.topobjdir:
                             continue
@@ -849,12 +847,12 @@ class RecursiveMakeBackend(CommonBackend):
                                           obj.unified_source_mapping,
                                           unified_files_makefile_variable=var,
                                           include_curdir_build_rules=False)
-            backend_file.write('%s += $(%s)\n' % (non_unified_var, var))
+            backend_file.write('{} += $({})\n'.format(non_unified_var, var))
         else:
             # Sorted so output is consistent and we don't bump mtimes.
             source_files = list(sorted(obj.files))
 
-            backend_file.write('%s += %s\n' % (
+            backend_file.write('{} += {}\n'.format(
                     non_unified_var, ' '.join(source_files)))
 
     def _process_directory_traversal(self, obj, backend_file):
@@ -879,7 +877,7 @@ class RecursiveMakeBackend(CommonBackend):
         defines = list(obj.get_defines())
         if defines:
             defines = ' '.join(shell_quote(d) for d in defines)
-            backend_file.write_once('%s += %s\n' % (which, defines))
+            backend_file.write_once('{} += {}\n'.format(which, defines))
 
     def _process_installation_target(self, obj, backend_file):
         # A few makefiles need to be able to override the following rules via
@@ -934,9 +932,9 @@ class RecursiveMakeBackend(CommonBackend):
             # listing the .idls here, we ensure the make file has a
             # reference to the new .idl. Since the new .idl presumably has
             # an mtime newer than the .xpt, it will trigger xpt generation.
-            xpt_path = '$(DEPTH)/%s/components/%s.xpt' % (install_target, module)
+            xpt_path = '$(DEPTH)/{}/components/{}.xpt'.format(install_target, module)
             xpt_files.add(xpt_path)
-            mk.add_statement('%s_deps = %s' % (module, ' '.join(deps)))
+            mk.add_statement('{}_deps = {}'.format(module, ' '.join(deps)))
 
             if install_target.startswith('dist/'):
                 path = mozpath.relpath(xpt_path, '$(DEPTH)/dist')
@@ -1064,12 +1062,12 @@ class RecursiveMakeBackend(CommonBackend):
 
     def _process_per_source_flag(self, per_source_flag, backend_file):
         for flag in per_source_flag.flags:
-            backend_file.write('%s_FLAGS += %s\n' % (mozpath.basename(per_source_flag.file_name), flag))
+            backend_file.write('{}_FLAGS += {}\n'.format(mozpath.basename(per_source_flag.file_name), flag))
 
     def _process_java_jar_data(self, jar, backend_file):
         target = jar.name
         backend_file.write('JAVA_JAR_TARGETS += %s\n' % target)
-        backend_file.write('%s_DEST := %s.jar\n' % (target, jar.name))
+        backend_file.write('{}_DEST := {}.jar\n'.format(target, jar.name))
         if jar.sources:
             backend_file.write('%s_JAVAFILES := %s\n' %
                 (target, ' '.join(jar.sources)))
@@ -1112,7 +1110,7 @@ class RecursiveMakeBackend(CommonBackend):
         backend_file.write('HOST_LIBRARY_NAME = %s\n' % libdef.basename)
 
     def _build_target_for_obj(self, obj):
-        return '%s/%s' % (mozpath.relpath(obj.objdir,
+        return '{}/{}'.format(mozpath.relpath(obj.objdir,
             self.environment.topobjdir), obj.KIND)
 
     def _process_linked_libraries(self, obj, backend_file):
@@ -1219,7 +1217,7 @@ class RecursiveMakeBackend(CommonBackend):
                         install_manifest.add_symlink(f.full_path, dest)
                 else:
                     install_manifest.add_optional_exists(dest)
-                    backend_file.write('%s_FILES += %s\n' % (
+                    backend_file.write('{}_FILES += {}\n'.format(
                         target_var, self._pretty_path(f, backend_file)))
                     have_objdir_files = True
             if have_objdir_files:
@@ -1228,7 +1226,7 @@ class RecursiveMakeBackend(CommonBackend):
                 backend_file.write('%s_DEST := $(DEPTH)/%s\n'
                                    % (target_var,
                                       mozpath.join(target, path)))
-                backend_file.write('%s_TARGET := %s\n' % (target_var, tier))
+                backend_file.write('{}_TARGET := {}\n'.format(target_var, tier))
                 backend_file.write('INSTALL_TARGETS += %s\n' % target_var)
 
     def _process_final_target_pp_files(self, obj, files, backend_file, name):
@@ -1244,7 +1242,7 @@ class RecursiveMakeBackend(CommonBackend):
             self._no_skip['misc'].add(backend_file.relobjdir)
             var = '%s_%d' % (name, i)
             for f in files:
-                backend_file.write('%s += %s\n' % (
+                backend_file.write('{} += {}\n'.format(
                     var, self._pretty_path(f, backend_file)))
             backend_file.write('%s_PATH := $(DEPTH)/%s\n'
                                % (var, mozpath.join(obj.install_target, path)))
@@ -1303,7 +1301,7 @@ class RecursiveMakeBackend(CommonBackend):
             for manifest in sorted(manifests):
                 master.write('[include:%s]\n' % manifest)
 
-    class Substitution(object):
+    class Substitution:
         """BaseConfigSubstitution-like class for use with _create_makefile."""
         __slots__ = (
             'input_path',
@@ -1326,20 +1324,20 @@ class RecursiveMakeBackend(CommonBackend):
                 pp.context.update(extra)
             if not pp.context.get('autoconfmk', ''):
                 pp.context['autoconfmk'] = 'autoconf.mk'
-            pp.handleLine(b'# THIS FILE WAS AUTOMATICALLY GENERATED. DO NOT MODIFY BY HAND.\n');
-            pp.handleLine(b'DEPTH := @DEPTH@\n')
-            pp.handleLine(b'topobjdir := @topobjdir@\n')
-            pp.handleLine(b'topsrcdir := @top_srcdir@\n')
-            pp.handleLine(b'srcdir := @srcdir@\n')
-            pp.handleLine(b'VPATH := @srcdir@\n')
-            pp.handleLine(b'relativesrcdir := @relativesrcdir@\n')
-            pp.handleLine(b'include $(DEPTH)/config/@autoconfmk@\n')
+            pp.handleLine('# THIS FILE WAS AUTOMATICALLY GENERATED. DO NOT MODIFY BY HAND.\n');
+            pp.handleLine('DEPTH := @DEPTH@\n')
+            pp.handleLine('topobjdir := @topobjdir@\n')
+            pp.handleLine('topsrcdir := @top_srcdir@\n')
+            pp.handleLine('srcdir := @srcdir@\n')
+            pp.handleLine('VPATH := @srcdir@\n')
+            pp.handleLine('relativesrcdir := @relativesrcdir@\n')
+            pp.handleLine('include $(DEPTH)/config/@autoconfmk@\n')
             if not stub:
                 pp.do_include(obj.input_path)
             # Empty line to avoid failures when last line in Makefile.in ends
             # with a backslash.
-            pp.handleLine(b'\n')
-            pp.handleLine(b'include $(topsrcdir)/config/recurse.mk\n')
+            pp.handleLine('\n')
+            pp.handleLine('include $(topsrcdir)/config/recurse.mk\n')
         if not stub:
             # Adding the Makefile.in here has the desired side-effect
             # that if the Makefile.in disappears, this will force
@@ -1367,15 +1365,15 @@ class RecursiveMakeBackend(CommonBackend):
                     '$< -o $@)'
             ])
 
-        mk.add_statement('ALL_IPDLSRCS := %s %s' % (' '.join(sorted_nonstatic_ipdl_basenames),
+        mk.add_statement('ALL_IPDLSRCS := {} {}'.format(' '.join(sorted_nonstatic_ipdl_basenames),
                          ' '.join(sorted_static_ipdl_sources)))
 
         self._add_unified_build_rules(mk, unified_ipdl_cppsrcs_mapping,
                                       unified_files_makefile_variable='CPPSRCS')
 
         # Preprocessed ipdl files are generated in ipdl_dir.
-        mk.add_statement('IPDLDIRS := %s %s' % (ipdl_dir, ' '.join(sorted(set(mozpath.dirname(p)
-            for p in sorted_static_ipdl_sources)))))
+        mk.add_statement('IPDLDIRS := {} {}'.format(ipdl_dir, ' '.join(sorted({mozpath.dirname(p)
+            for p in sorted_static_ipdl_sources}))))
 
         with self._write_file(mozpath.join(ipdl_dir, 'ipdlsrcs.mk')) as ipdls:
             mk.dump(ipdls, removal_guard=False)
diff --git a/python/mozbuild/mozbuild/backend/tup.py b/python/mozbuild/mozbuild/backend/tup.py
index b148532c89..adb4f172e7 100644
--- a/python/mozbuild/mozbuild/backend/tup.py
+++ b/python/mozbuild/mozbuild/backend/tup.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import os
 
@@ -26,7 +25,7 @@ from ..util import (
 )
 
 
-class BackendTupfile(object):
+class BackendTupfile:
     """Represents a generated Tupfile.
     """
 
@@ -72,13 +71,13 @@ class BackendTupfile(object):
         else:
             caret_text = flags
 
-        self.write(': %(inputs)s |> %(display)s%(cmd)s |> %(outputs)s%(extra_outputs)s\n' % {
-            'inputs': ' '.join(inputs),
-            'display': '^%s^ ' % caret_text if caret_text else '',
-            'cmd': ' '.join(cmd),
-            'outputs': ' '.join(outputs),
-            'extra_outputs': ' | ' + ' '.join(extra_outputs) if extra_outputs else '',
-        })
+        self.write(': {inputs} |> {display}{cmd} |> {outputs}{extra_outputs}\n'.format(
+            inputs=' '.join(inputs),
+            display='^%s^ ' % caret_text if caret_text else '',
+            cmd=' '.join(cmd),
+            outputs=' '.join(outputs),
+            extra_outputs=' | ' + ' '.join(extra_outputs) if extra_outputs else '',
+        ))
 
     def export_shell(self):
         if not self.shell_exported:
@@ -182,7 +181,7 @@ class TupOnly(CommonBackend, PartialBackend):
         with self._write_file(mozpath.join(self.environment.topobjdir, 'Tuprules.tup')) as fh:
             acdefines = [name for name in self.environment.defines
                 if not name in self.environment.non_global_defines]
-            acdefines_flags = ' '.join(['-D%s=%s' % (name,
+            acdefines_flags = ' '.join(['-D{}={}'.format(name,
                 shell_quote(self.environment.defines[name]))
                 for name in sorted(acdefines)])
             # TODO: AB_CD only exists in Makefiles at the moment.
@@ -253,7 +252,7 @@ class TupOnly(CommonBackend, PartialBackend):
         backend_file = self._get_backend_file('xpcom/xpidl')
         backend_file.export_shell()
 
-        for module, data in sorted(manager.modules.iteritems()):
+        for module, data in sorted(manager.modules.items()):
             dest, idls = data
             cmd = [
                 '$(PYTHON_PATH)',
@@ -269,7 +268,7 @@ class TupOnly(CommonBackend, PartialBackend):
             ]
             cmd.extend(sorted(idls))
 
-            outputs = ['$(MOZ_OBJ_ROOT)/%s/components/%s.xpt' % (dest, module)]
+            outputs = ['$(MOZ_OBJ_ROOT)/{}/components/{}.xpt'.format(dest, module)]
             outputs.extend(['$(MOZ_OBJ_ROOT)/dist/include/%s.h' % f for f in sorted(idls)])
             backend_file.rule(
                 inputs=[
diff --git a/python/mozbuild/mozbuild/base.py b/python/mozbuild/mozbuild/base.py
index 24791b6182..273b9cc353 100644
--- a/python/mozbuild/mozbuild/base.py
+++ b/python/mozbuild/mozbuild/base.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
+from __future__ import print_function
 import json
 import logging
 import mozpack.path as mozpath
@@ -61,7 +61,7 @@ class ObjdirMismatchException(BadEnvironmentException):
         self.objdir2 = objdir2
 
     def __str__(self):
-        return "Objdir mismatch: %s != %s" % (self.objdir1, self.objdir2)
+        return "Objdir mismatch: {} != {}".format(self.objdir1, self.objdir2)
 
 
 class MozbuildObject(ProcessExecutionMixin):
@@ -126,7 +126,7 @@ class MozbuildObject(ProcessExecutionMixin):
         mozconfig = MozconfigLoader.AUTODETECT
 
         def load_mozinfo(path):
-            info = json.load(open(path, 'rt'))
+            info = json.load(open(path))
             topsrcdir = info.get('topsrcdir')
             topobjdir = os.path.dirname(path)
             mozconfig = info.get('mozconfig')
@@ -368,7 +368,7 @@ class MozbuildObject(ProcessExecutionMixin):
         args = o._normalize_command([p], True)
 
         _config_guess_output.append(
-                subprocess.check_output(args, cwd=self.topsrcdir).strip())
+                subprocess.check_output(args, cwd=self.topsrcdir).strip().decode('utf-8', errors='replace'))
         return _config_guess_output[0]
 
     def notify(self, msg):
@@ -430,7 +430,7 @@ class MozbuildObject(ProcessExecutionMixin):
                 FlashWindowEx(params)
         except Exception as e:
             self.log(logging.WARNING, 'notifier-failed', {'error':
-                e.message}, 'Notification center failed: {error}')
+                str(e)}, 'Notification center failed: {error}')
 
     def _ensure_objdir_exists(self):
         if os.path.isdir(self.statedir):
@@ -489,7 +489,7 @@ class MozbuildObject(ProcessExecutionMixin):
             for flag in flags:
                 if flag == '-j':
                     try:
-                        flag = flags.next()
+                        flag = next(flags)
                     except StopIteration:
                         break
                     try:
@@ -534,7 +534,7 @@ class MozbuildObject(ProcessExecutionMixin):
             fn = self._run_command_in_srcdir
 
         append_env = dict(append_env or ())
-        append_env[b'MACH'] = '1'
+        append_env['MACH'] = '1'
 
         params = {
             'args': args,
@@ -674,19 +674,19 @@ class MachCommandBase(MozbuildObject):
         except BuildEnvironmentNotFoundException:
             pass
         except ObjdirMismatchException as e:
-            print('Ambiguous object directory detected. We detected that '
+            print(('Ambiguous object directory detected. We detected that '
                 'both %s and %s could be object directories. This is '
                 'typically caused by having a mozconfig pointing to a '
                 'different object directory from the current working '
                 'directory. To solve this problem, ensure you do not have a '
                 'default mozconfig in searched paths.' % (e.objdir1,
-                    e.objdir2))
+                    e.objdir2)))
             sys.exit(1)
 
         except MozconfigLoadException as e:
-            print('Error loading mozconfig: ' + e.path)
+            print(('Error loading mozconfig: ' + e.path))
             print('')
-            print(e.message)
+            print((e.message))
             if e.output:
                 print('')
                 print('mozconfig output:')
@@ -708,13 +708,13 @@ class MachCommandBase(MozbuildObject):
             self.mozconfig
 
         except MozconfigFindException as e:
-            print(e.message)
+            print((e.message))
             sys.exit(1)
 
         except MozconfigLoadException as e:
-            print('Error loading mozconfig: ' + e.path)
+            print(('Error loading mozconfig: ' + e.path))
             print('')
-            print(e.message)
+            print((e.message))
             if e.output:
                 print('')
                 print('mozconfig output:')
@@ -732,14 +732,14 @@ class MachCommandBase(MozbuildObject):
             self._ensure_state_subdir_exists('.')
             logfile = self._get_state_filename('last_log.json')
             try:
-                fd = open(logfile, "wb")
+                fd = open(logfile, "w")
                 self.log_manager.add_json_handler(fd)
             except Exception as e:
                 self.log(logging.WARNING, 'mach', {'error': e},
                          'Log will not be kept for this command: {error}.')
 
 
-class MachCommandConditions(object):
+class MachCommandConditions:
     """A series of commonly used condition functions which can be applied to
     mach commands with providers deriving from MachCommandBase.
     """
@@ -793,7 +793,7 @@ class MachCommandConditions(object):
         return False
 
 
-class PathArgument(object):
+class PathArgument:
     """Parse a filesystem path argument and transform it in various ways."""
 
     def __init__(self, arg, topsrcdir, topobjdir, cwd=None):
diff --git a/python/mozbuild/mozbuild/compilation/codecomplete.py b/python/mozbuild/mozbuild/compilation/codecomplete.py
index 05583961a5..3ad5ca0d1a 100644
--- a/python/mozbuild/mozbuild/compilation/codecomplete.py
+++ b/python/mozbuild/mozbuild/compilation/codecomplete.py
@@ -4,8 +4,8 @@
 
 # This modules provides functionality for dealing with code completion.
 
-from __future__ import absolute_import
 
+from __future__ import print_function
 import os
 
 from mach.decorators import (
@@ -59,5 +59,5 @@ class Introspection(MachCommandBase):
         # Drop the first flag since that is the pathname of the compiler.
         flags = (shell_split(build_vars[cc]) + shell_split(build_vars[name]))[1:]
 
-        print(' '.join(shell_quote(arg)
-                       for arg in util.sanitize_cflags(flags)))
+        print((' '.join(shell_quote(arg)
+                       for arg in util.sanitize_cflags(flags))))
diff --git a/python/mozbuild/mozbuild/compilation/database.py b/python/mozbuild/mozbuild/compilation/database.py
index 20b09df488..4b3978a937 100644
--- a/python/mozbuild/mozbuild/compilation/database.py
+++ b/python/mozbuild/mozbuild/compilation/database.py
@@ -118,7 +118,7 @@ class CompileDBBackend(CommonBackend):
 
         db = []
 
-        for (directory, filename), cmd in self._db.iteritems():
+        for (directory, filename), cmd in self._db.items():
             env = self._envs[directory]
             cmd = list(cmd)
             cmd.append(filename)
@@ -151,7 +151,7 @@ class CompileDBBackend(CommonBackend):
                 a = expand_variables(a, variables).split()
                 if not a:
                     continue
-                if isinstance(a, types.StringTypes):
+                if isinstance(a, (str,)):
                     c.append(a)
                 else:
                     c.extend(a)
@@ -216,7 +216,7 @@ class CompileDBBackend(CommonBackend):
             value = cenv.substs.get(name)
             if not value:
                 return
-            if isinstance(value, types.StringTypes):
+            if isinstance(value, (str,)):
                 value = value.split()
             db.extend(value)
 
